#include "fncfunctions.h"



/* structures for function table */
HX_FDInfo *hx_dfinfo=NULL;
int hx_nb_dfinfo=0;
/* same, but used to temp moves when creating final list */
HX_FDInfo *hx_tmp_dfinfo=NULL;
int hx_nb_tmp_dfinfo=0;



/* insert the given name in the function list */
unsigned int hx_insert_name(char *name, void *fnc)
{
  unsigned int i;

  if (name == NULL)
    name = "??";
  for(i=0; i<hx_nb_dfinfo; i++)
    {
    if (fnc == hx_dfinfo[i].function)
      {
      if ((hx_dfinfo[i].name == NULL)||(hx_dfinfo[i].name[0] == '<'))
        hx_dfinfo[i].name = strdup(name);
	if (hx_dfinfo[i].name == NULL)
	  {
	  fprintf(stderr, "fncdump: Memory error!\n");
	  }
	return(i+1);
      }
    }
  /* no match: the symbol not belong to tracked functions */
  return(0);
}



char *hx_get_name_by_ptr(void *fnc, int nbinfo)
{
  int i;

  for(i=0; i<nbinfo; i++)
    {
    if (hx_dfinfo[i].function == fnc)
      return(hx_dfinfo[i].name);
    }
  return("<error>"); /* may not occur */
}

int hx_get_func_by_ptr(void *fnc, int nbinfo)
{
  int i;

  for(i=0; i<nbinfo; i++)
    {
    if (hx_dfinfo[i].function == fnc)
      return(i+1);
    }
  return(0); /* may not occur */
}

/* check if a given function is in the given list */
int hx_is_in_list(char *name, char **lst)
{
  int i;

  if (lst == NULL)
    return(0);  /* no list */
  i = 0;
  while(lst[i] != NULL)
    {
    if (strcmp(lst[i], name) == 0)
      return(1);
    i++;
    }
  return(0);
}
