#ifndef __fncgraph_h_
#define __fncgraph_h_



/** includes **/
#include "fnccommon.h"
#include "fnctools.h"



/** functions **/
/* create a new node for a given function */
HX_Node *hx_create_node(HX_FDInfo *function);
/* add a child to a node */
int hx_add_child(HX_Node *node, HX_Node *child);
/* add a child to a node */
int hx_add_prev(HX_Node *node, HX_Node *prev);
/* propagate given value (0/1) from the given node */ 
void hx_propagate_to_child(HX_Node*node, int val);
/* retro-propagate given value (0/1) from the given node */ 
void hx_propagate_to_caller(HX_Node*node, int val);
/* propagate given value (0/1) from the given node */ 
void hx_propagate_to_child_p(HX_Node*node);
/* retro-propagate given value (0/1) from the given node */ 
void hx_propagate_to_caller_p(HX_Node*node);
/* propagate tags to nodes */
void hx_tag_nodes(HX_Node *node, int tag);
void hx_display_recurs(int options, HX_Node *node, unsigned int nc);
void hx_display_cycle(int options, HX_Node *end, HX_Node *start, unsigned int nc);
/* compute list of cycles */
int hx_compute_cycles(int options, HX_Node **nodes, int nbinfo);




#endif /* __fncgraph_h_ */
