#include "fnctools.h"

/* temp buffer... */
#define MAX_BUFFER 1024

/* debug level */
int hx_debug_level=0;

/* app name */
char *hx_my_name="fncdump";

/* sort type */
char *fncchk_sort_names[FNCCHK_SORT_MAX+2] =
        {HX_SRT_NDEF, HX_SRT_LOC,HX_SRT_TOT,
         HX_SRT_CALL,HX_SRT_NAME,
	 HX_SRT_NON, HX_SRT_NDEF};


/* display a message with app name */
void hxmessage(char *format, ...)
{
  va_list args;
  char buffer[MAX_BUFFER];

  va_start(args, format);
  fprintf(stderr, "%s: ", hx_my_name);
  vsprintf(buffer, format, args);
  fprintf(stderr, buffer);
  fprintf(stderr, "\n");
  va_end(args);
}

/* display a 'fatal error' message */
void hxfatal(int ret)
{
  fprintf(stderr, "%s: Fatal error!\n", hx_my_name);
  exit(ret);
}

/* display a 'fatal error' message */
void hxfatal_msg()
{
  fprintf(stderr, "%s: Fatal error!\n", hx_my_name);
}


/* display a debug message "ala" printf, with app name,
   function/file/line where the caller is */
void hx_real_printf(char*file, char*func, int line, int dlevel, char *format, ...)
{
  va_list args;
  char buffer[MAX_BUFFER];

  if (dlevel <= hx_debug_level)
    {
    va_start(args, format);
    fprintf(stderr, "%s:%s(%s:%d): ", hx_my_name, func, file, line);
    vsprintf(buffer, format, args);
    fprintf(stderr, buffer);
    fprintf(stderr, "\n");
    va_end(args);
    }
}
