#include "fncfunction.h"





/* add the caller reference in function */
/* CHANGES: add the call_site for display purpose */
inline void hx_register_caller(unsigned int who, unsigned int from, void *rfrom)
{
  unsigned int i;

  hxprintf(4, "(%d, %d, %p)", who, from, rfrom);

  if (hx_hx_dfinfo[who].nb_of_callers >= HX_MAX_CALLER)
    return; /* list is full */
  for(i=0; i<hx_hx_dfinfo[who].nb_of_callers; i++)
    {
    if (hx_hx_dfinfo[who].called_by[i] == hx_hx_dfinfo[from].function)
      {
      hx_hx_dfinfo[who].nb_called_by[i]++;
      return;  /* still referenced */
      }
    }
  hx_hx_dfinfo[who].nb_called_by[hx_hx_dfinfo[who].nb_of_callers] = 1;
  hx_hx_dfinfo[who].called_by[hx_hx_dfinfo[who].nb_of_callers] =
        hx_hx_dfinfo[from].function;
  hx_hx_dfinfo[who].rcalled_by[hx_hx_dfinfo[who].nb_of_callers] =
        rfrom;
  hx_hx_dfinfo[who].nb_of_callers++;

  hxprintf(4, "leaving (%d, %d, %p)", who, from, rfrom);
}


/* search a function (+1) (or 0) */
inline unsigned int hx_search_function(void *fnc)
{
  unsigned int i, key, pos;

  key = (((unsigned int)fnc)/4) % hx_nb_hash_list;
  for(i=0; i<HX_MAX_HASH_EL; i++)
    {
    if (hx_hash_list[key][i].fnc == NULL)
      {/* no more entries. register */
      pos = hx_register_function(fnc);
      hx_hash_list[key][i].fnc = fnc;
      hx_hash_list[key][i].pos = pos-1;
      return(pos);
      }
    if (hx_hash_list[key][i].fnc == fnc)
      return(hx_hash_list[key][i].pos+1);
    }
  /* error! full! */
  hxmessage("max number of colision in hash-table reached.");
  hxfatal(HX_ERR_HASH);
  return(0); /* never reached. just to prevent warnings */
}



/* add a new function in the table */
inline unsigned int hx_register_function(void *fnc)
{
  hxprintf(4, "(%p)", fnc);

  /* too many functions */
  if (hx_nb_finfos >= hx_max_nb_finfos)
    {/* 0 -> error */
    if (hx_dynamic_mode)
      {
      if (hx_trace_memory)  /* dont trace this */
        hx_trace_suspend = 1;
      hx_reallocate_fatal(hx_hx_dfinfo, hx_max_nb_finfos*2);
      /*
      if ((hx_hx_dfinfo = realloc(hx_hx_dfinfo, sizeof(HX_FInfo)*(hx_max_nb_finfos*2))) == NULL)
        {
	fprintf(stderr, "fnccheck: Memory error!\n");
	fprintf(stderr, "fnccheck: Fatal error! Abort!\n");
        hx_internal_exit = 1;
        exit(1);
	}
      */
      if (hx_trace_memory)
        hx_trace_suspend = 0;
      hx_nb_of_realloc++;
      hx_max_nb_finfos *= 2;
      }
    else
      {
      hxmessage("max number of function reached.");
      hxmessage("switch to dynamic allocation by setting FNCCHK_DYNAMIC=1.");
      hxfatal(HX_ERR_FUNC);
      exit(1);
      }
    }
  /* initializations */
  hx_hx_dfinfo[hx_nb_finfos].function   = fnc;
  hx_hx_dfinfo[hx_nb_finfos].nb_calls   = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_sec     = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_usec    = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_locsec  = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_locusec = 0;
  hx_hx_dfinfo[hx_nb_finfos].min_sec    = 0;
  hx_hx_dfinfo[hx_nb_finfos].min_usec   = 0;
  hx_hx_dfinfo[hx_nb_finfos].max_sec    = 0;
  hx_hx_dfinfo[hx_nb_finfos].max_usec   = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_of_callers = 0;
  hx_hx_dfinfo[hx_nb_finfos].recurs_count  = 0;
  hx_hx_dfinfo[hx_nb_finfos].nb_in_stack   = 0;
  
  hx_nb_finfos++;
  
  hxprintf(4, "leaving (%p)", fnc);

  /* return the number of functions */
  return(hx_nb_finfos);
}

