/* this file provides time manipulation functions */

/** includes **/
#include "fnctime.h"
#include <unistd.h>



/** not realy nice. needed by hx_gettimeofday **/
extern int hx_time_type;


/** variables that are only local to this module **/
clock_t hx_last_given;  /* used for time loops */
/* for time */
unsigned long int hx_last_time=0;
struct timeval hx_current_time={0,0};
unsigned long int hx_time_loop=0;

long hx_time_rez;
long hx_time_fac;

#ifdef HAVE_LIBPTHREADS
#define MAXTHR	1024
clock_t hx_last[MAXTHR];
#endif



/* duh! */
inline unsigned long int hx_2pow(unsigned int v)
{
  unsigned long int ret=1;
  unsigned int i;

  for(i=0; i<v; i++)
    ret *= 2;
  return(ret);
}


/* set the time mode */
inline int hx_set_time_type(char *buf)
{
  if (strcasecmp(buf, "ext") == 0)
    {
    return(HX_TIME_EXT);
    }
  else
  if (strcasecmp(buf, "cpu") == 0)
    {
    return(HX_TIME_CPU);
    }
  else
  if (strcasecmp(buf, "sys") == 0)
    {
    return(HX_TIME_SYS);
    }
  else
    {
    hxmessage("time: invalid value for 'FNCCHK_TIME' (%s).", buf);
    hxmessage("time: ignored (EXT used).");
    }
  return(HX_TIME_EXT);
}


/* init the time system */
inline void hx_init_time()
{
  /* init time */
  hx_last_time = (unsigned long int)clock();
  /* compute time-loop for 'times' */
  hx_time_loop = hx_2pow((unsigned int)(8*sizeof(clock_t))) / 2;
  hx_time_rez = sysconf(_SC_CLK_TCK);
  hx_time_fac = 1000000 / hx_time_rez;
}


/* my 'gettimeofday'. Returnsa 'timeval' structure containing
   the current time (in the good clock-mode) */
inline void hx_gettimeofday(struct timeval *tv)
{
  struct tms tmbuf;
  long int delta;

  /* standard case */
  if (hx_time_type == HX_TIME_EXT)
    {
    gettimeofday(tv, NULL);
    return;
    }
  /* CPU/SYS time */
  times(&tmbuf);
#if 0
  /* over the limit ? */
  if (result < hx_last_time)
    {
    delta = (result + hx_time_loop - hx_last_time);
    }
  else
    {
    delta = (result - hx_last_time);
    }
  /* ask to P.S. to test this part in this site */  
  /* can only be used if CLOCK_PER_SEC == 1000000 */
  /* some troubles reported... still checking */
  tv->tv_usec = delta % CLOCKS_PER_SEC;
  hx_current_time.tv_usec += tv->tv_usec;
  hx_current_time.tv_sec += ((delta - tv->tv_usec) / 1000000);
  if (hx_current_time.tv_usec >= 1000000)
    {
    hx_current_time.tv_usec -= 1000000;
    hx_current_time.tv_sec += 1;
    }
  tv->tv_sec  = hx_current_time.tv_sec;
  tv->tv_usec = hx_current_time.tv_usec;
  
  hx_last_time = result;
#else
/*	delta = result - hx_last_time;
	if (delta < 0) delta ^= 0x80000000L; */

	tv->tv_usec = (tmbuf.tms_utime % hx_time_rez) * hx_time_fac;
	tv->tv_sec = tmbuf.tms_utime / hx_time_rez;
	if (hx_time_type == HX_TIME_SYS) {
		tv->tv_usec += (tmbuf.tms_stime % hx_time_rez) * hx_time_fac;
		tv->tv_sec += tmbuf.tms_stime / hx_time_rez;
		if (tv->tv_usec > 1000000) {
			tv->tv_usec -= 1000000;
			tv->tv_sec ++;
		}
	}
#endif
}

/* substract d[u]sec to [u]sec */
inline void hx_substract_time(unsigned long int *sec,
                              unsigned long int *usec,
                              unsigned long int dsec,
                              unsigned long int dusec)
{
  unsigned long int sup=0;
  if (dusec > *usec)
    {
    *usec = (1000000+*usec) - dusec;
    sup = 1;
    }
  else
    {
    *usec = *usec - dusec;
    }
  *sec = *sec - dsec - sup;
}


/* compute elapsed time between the two times */
inline void hx_compute_elapsed_time(unsigned long int sec1, unsigned long int usec1,
                         unsigned long int sec2, unsigned long int usec2,
			 long *secr, long *usecr)
{
  if (sec1 == sec2)
    {
    *secr  = 0;
    *usecr = usec2 - usec1;
    }
  else
    {
    *secr  = sec2 - sec1 - 1;
    *usecr = usec2 + 1000000-usec1;
    }
  if (*usecr >= 1000000)
    {
    *secr  += 1;
    *usecr -= 1000000;
    }
}

