#include "fnctools.h"

/* temp buffer... */
#define MAX_BUFFER 1024

/* debug level */
int hx_debug_level=0;

/* app name */
char *hx_lib_name=FNCCHK_LIB_NAME;


/* display a message with app name */
void hxmessage(char *format, ...)
{
  va_list args;
  char buffer[MAX_BUFFER];

  va_start(args, format);
  fprintf(stderr, "%s: ", hx_lib_name);
  vsprintf(buffer, format, args);
  fprintf(stderr, buffer);
  fprintf(stderr, "\n");
  va_end(args);
}

/* display a 'fatal error' message */
void hxfatal(int ret)
{
  fprintf(stderr, "%s: Fatal error!\n", hx_lib_name);
  hx_internal_exit = 1;
  exit(ret);
}


/* display a debug message "ala" printf, with app name,
   function/file/line where the caller is */
void hx_real_printf(char*file, char*func, int line, int dlevel, char *format, ...)
{
  va_list args;
  char buffer[MAX_BUFFER];

  if (dlevel <= hx_debug_level)
    {
    va_start(args, format);
    fprintf(stderr, "%s:%s(%s:%d): ", hx_lib_name, func, file, line);
    vsprintf(buffer, format, args);
    fprintf(stderr, buffer);
    fprintf(stderr, "\n");
    va_end(args);
    }
}
